Index: uspace/drv/nic/ne2k/ne2k.c
===================================================================
--- uspace/drv/nic/ne2k/ne2k.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/drv/nic/ne2k/ne2k.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -38,4 +38,7 @@
  */
 
+/* XXX Fix this */
+#define _DDF_DATA_IMPLANT
+
 #include <stdio.h>
 #include <errno.h>
@@ -61,5 +64,5 @@
 #define IRQ_GET_TSR(call)  ((int) IPC_GET_ARG3(call))
 
-#define DRIVER_DATA(dev) ((nic_t *) ((dev)->driver_data))
+#define DRIVER_DATA(dev) ((nic_t *) ddf_dev_data_get(dev))
 #define NE2K(device) ((ne2k_t *) nic_get_specific(DRIVER_DATA(device)))
 
@@ -169,5 +172,5 @@
 static void ne2k_dev_cleanup(ddf_dev_t *dev)
 {
-	if (dev->driver_data != NULL) {
+	if (ddf_dev_data_get(dev) != NULL) {
 		ne2k_t *ne2k = NE2K(dev);
 		if (ne2k) {
@@ -177,8 +180,4 @@
 		nic_unbind_and_destroy(dev);
 	}
-	if (dev->parent_sess != NULL) {
-		async_hangup(dev->parent_sess);
-		dev->parent_sess = NULL;
-	}
 }
 
@@ -279,5 +278,5 @@
 static int ne2k_set_address(ddf_fun_t *fun, const nic_address_t *address)
 {
-	nic_t *nic_data = DRIVER_DATA(fun);
+	nic_t *nic_data = DRIVER_DATA(ddf_fun_get_dev(fun));
 	int rc = nic_report_address(nic_data, address);
 	if (rc != EOK) {
@@ -410,6 +409,6 @@
 	}
 	nic_set_ddf_fun(nic_data, fun);
-	fun->ops = &ne2k_dev_ops;
-	fun->driver_data = nic_data;
+	ddf_fun_set_ops(fun, &ne2k_dev_ops);
+	ddf_fun_data_implant(fun, nic_data);
 	
 	rc = ddf_fun_bind(fun);
Index: uspace/drv/nic/rtl8139/driver.c
===================================================================
--- uspace/drv/nic/rtl8139/driver.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/drv/nic/rtl8139/driver.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -27,4 +27,7 @@
  */
 
+/* XXX Fix this */
+#define _DDF_DATA_IMPLANT
+
 #include <assert.h>
 #include <errno.h>
@@ -212,13 +215,12 @@
 	rtl8139_regs_lock(rtl8139->io_port);
 
+	async_sess_t *pci_sess =
+		ddf_dev_parent_sess_get(nic_get_ddf_dev(rtl8139->nic_data));
+
 	if (bit_val) {
-		async_sess_t *pci_sess =
-			nic_get_ddf_dev(rtl8139->nic_data)->parent_sess;
 		uint8_t pmen;
 		pci_config_space_read_8(pci_sess, 0x55, &pmen);
 		pci_config_space_write_8(pci_sess, 0x55, pmen | 1 | (1 << 7));
 	} else {
-		async_sess_t *pci_sess =
-			nic_get_ddf_dev(rtl8139->nic_data)->parent_sess;
 		uint8_t pmen;
 		pci_config_space_read_8(pci_sess, 0x55, &pmen);
@@ -1052,11 +1054,6 @@
 	assert(dev);
 
-	if (dev->driver_data)
+	if (ddf_dev_data_get(dev))
 		nic_unbind_and_destroy(dev);
-
-	if (dev->parent_sess != NULL) {
-		async_hangup(dev->parent_sess);
-		dev->parent_sess = NULL;
-	}
 }
 
@@ -1080,22 +1077,22 @@
 
 	if (hw_resources->irqs.count != 1) {
-		ddf_msg(LVL_ERROR, "%s device: unexpected irq count", dev->name);
+		ddf_msg(LVL_ERROR, "%s device: unexpected irq count", ddf_dev_get_name(dev));
 		return EINVAL;
 	};
 	if (hw_resources->io_ranges.count != 1) {
-		ddf_msg(LVL_ERROR, "%s device: unexpected io ranges count", dev->name);
+		ddf_msg(LVL_ERROR, "%s device: unexpected io ranges count", ddf_dev_get_name(dev));
 		return EINVAL;
 	}
 
 	rtl8139->irq = hw_resources->irqs.irqs[0];
-	ddf_msg(LVL_DEBUG, "%s device: irq 0x%x assigned", dev->name, rtl8139->irq);
+	ddf_msg(LVL_DEBUG, "%s device: irq 0x%x assigned", ddf_dev_get_name(dev), rtl8139->irq);
 
 	rtl8139->io_addr = IOADDR_TO_PTR(hw_resources->io_ranges.ranges[0].address);
 	if (hw_resources->io_ranges.ranges[0].size < RTL8139_IO_SIZE) {
 		ddf_msg(LVL_ERROR, "i/o range assigned to the device "
-		    "%s is too small.", dev->name);
+		    "%s is too small.", ddf_dev_get_name(dev));
 		return EINVAL;
 	}
-	ddf_msg(LVL_DEBUG, "%s device: i/o addr %p assigned.", dev->name, rtl8139->io_addr);
+	ddf_msg(LVL_DEBUG, "%s device: i/o addr %p assigned.", ddf_dev_get_name(dev), rtl8139->io_addr);
 
 	return EOK;
@@ -1192,5 +1189,5 @@
 static int rtl8139_device_initialize(ddf_dev_t *dev)
 {
-	ddf_msg(LVL_DEBUG, "rtl8139_dev_initialize %s", dev->name);
+	ddf_msg(LVL_DEBUG, "rtl8139_dev_initialize %s", ddf_dev_get_name(dev));
 
 	int ret = EOK;
@@ -1201,5 +1198,5 @@
 	rtl8139_t *rtl8139 = rtl8139_create_dev_data(dev);
 	if (rtl8139 == NULL) {
-		ddf_msg(LVL_ERROR, "Not enough memory for initializing %s.", dev->name);
+		ddf_msg(LVL_ERROR, "Not enough memory for initializing %s.", ddf_dev_get_name(dev));
 		return ENOMEM;
 	}
@@ -1246,5 +1243,5 @@
 static int rtl8139_pio_enable(ddf_dev_t *dev)
 {
-	ddf_msg(LVL_DEBUG, NAME ": rtl8139_pio_enable %s", dev->name);
+	ddf_msg(LVL_DEBUG, NAME ": rtl8139_pio_enable %s", ddf_dev_get_name(dev));
 
 	rtl8139_t *rtl8139 = nic_get_specific(nic_get_from_ddf_dev(dev));
@@ -1253,5 +1250,5 @@
 	if (pio_enable(rtl8139->io_addr, RTL8139_IO_SIZE, &rtl8139->io_port)) {
 		ddf_msg(LVL_ERROR, "Cannot gain the port %lx for device %s.", rtl8139->io_addr,
-		    dev->name);
+		    ddf_dev_get_name(dev));
 		return EADDRNOTAVAIL;
 	}
@@ -1299,5 +1296,6 @@
 
 	assert(dev);
-	ddf_msg(LVL_NOTE, "RTL8139_dev_add %s (handle = %d)", dev->name, dev->handle);
+	ddf_msg(LVL_NOTE, "RTL8139_dev_add %s (handle = %d)",
+	    ddf_dev_get_name(dev), ddf_dev_get_handle(dev));
 
 	/* Init device structure for rtl8139 */
@@ -1340,6 +1338,6 @@
 	}
 	nic_set_ddf_fun(nic_data, fun);
-	fun->ops = &rtl8139_dev_ops;
-	fun->driver_data = nic_data;
+	ddf_fun_set_ops(fun, &rtl8139_dev_ops);
+	ddf_fun_data_implant(fun, nic_data);
 
 	rc = ddf_fun_bind(fun);
@@ -1355,5 +1353,5 @@
 
 	ddf_msg(LVL_NOTE, "The %s device has been successfully initialized.",
-	    dev->name);
+	    ddf_dev_get_name(dev));
 
 	return EOK;
Index: uspace/drv/test/test1/test1.c
===================================================================
--- uspace/drv/test/test1/test1.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/drv/test/test1/test1.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -145,13 +145,16 @@
 	ddf_fun_t *fun_a;
 	test1_t *test1;
-	int rc;
-
+	const char *dev_name;
+	int rc;
+
+	dev_name = ddf_dev_get_name(dev);
 	ddf_msg(LVL_DEBUG, "dev_add(name=\"%s\", handle=%d)",
-	    dev->name, (int) dev->handle);
+	    dev_name, (int) ddf_dev_get_handle(dev));
 
 	test1 = ddf_dev_data_alloc(dev, sizeof(test1_t));
 	if (test1 == NULL) {
 		ddf_msg(LVL_ERROR, "Failed allocating soft state.\n");
-		return ENOMEM;
+		rc = ENOMEM;
+		goto error;
 	}
 
@@ -159,5 +162,6 @@
 	if (fun_a == NULL) {
 		ddf_msg(LVL_ERROR, "Failed creating function 'a'.");
-		return ENOMEM;
+		rc = ENOMEM;
+		goto error;
 	}
 
@@ -168,13 +172,13 @@
 		ddf_msg(LVL_ERROR, "Failed binding function 'a'.");
 		ddf_fun_destroy(fun_a);
-		return rc;
+		goto error;
 	}
 
 	ddf_fun_add_to_category(fun_a, "virtual");
 
-	if (str_cmp(dev->name, "null") == 0) {
-		fun_a->ops = &char_device_ops;
+	if (str_cmp(dev_name, "null") == 0) {
+		ddf_fun_set_ops(fun_a,  &char_device_ops);
 		ddf_fun_add_to_category(fun_a, "virt-null");
-	} else if (str_cmp(dev->name, "test1") == 0) {
+	} else if (str_cmp(dev_name, "test1") == 0) {
 		(void) register_fun_verbose(dev,
 		    "cloning myself ;-)", "clone",
@@ -183,5 +187,5 @@
 		    "cloning myself twice ;-)", "clone",
 		    "virtual&test1", 10, EEXISTS, NULL);
-	} else if (str_cmp(dev->name, "clone") == 0) {
+	} else if (str_cmp(dev_name, "clone") == 0) {
 		(void) register_fun_verbose(dev,
 		    "run by the same task", "child",
@@ -189,7 +193,8 @@
 	}
 
-	ddf_msg(LVL_DEBUG, "Device `%s' accepted.", dev->name);
-
-	return EOK;
+	ddf_msg(LVL_DEBUG, "Device `%s' accepted.", dev_name);
+	return EOK;
+error:
+	return rc;
 }
 
@@ -232,5 +237,5 @@
 static int test1_dev_remove(ddf_dev_t *dev)
 {
-	test1_t *test1 = (test1_t *)dev->driver_data;
+	test1_t *test1 = (test1_t *)ddf_dev_data_get(dev);
 	int rc;
 
@@ -260,5 +265,5 @@
 static int test1_dev_gone(ddf_dev_t *dev)
 {
-	test1_t *test1 = (test1_t *)dev->driver_data;
+	test1_t *test1 = (test1_t *)ddf_dev_data_get(dev);
 	int rc;
 
Index: uspace/drv/test/test2/test2.c
===================================================================
--- uspace/drv/test/test2/test2.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/drv/test/test2/test2.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -196,7 +196,8 @@
 {
 	test2_t *test2;
+	const char *dev_name = ddf_dev_get_name(dev);
 
 	ddf_msg(LVL_DEBUG, "test2_dev_add(name=\"%s\", handle=%d)",
-	    dev->name, (int) dev->handle);
+	    dev_name, (int) ddf_dev_get_handle(dev));
 
 	test2 = ddf_dev_data_alloc(dev, sizeof(test2_t));
@@ -208,5 +209,5 @@
 	test2->dev = dev;
 
-	if (str_cmp(dev->name, "child") != 0) {
+	if (str_cmp(dev_name, "child") != 0) {
 		fid_t postpone = fibril_create(plug_unplug, test2);
 		if (postpone == 0) {
@@ -225,5 +226,5 @@
 static int test2_dev_remove(ddf_dev_t *dev)
 {
-	test2_t *test2 = (test2_t *)dev->driver_data;
+	test2_t *test2 = (test2_t *)ddf_dev_data_get(dev);
 	int rc;
 
@@ -259,5 +260,5 @@
 static int test2_dev_gone(ddf_dev_t *dev)
 {
-	test2_t *test2 = (test2_t *)dev->driver_data;
+	test2_t *test2 = (test2_t *)ddf_dev_data_get(dev);
 	int rc;
 
Index: uspace/drv/test/test3/test3.c
===================================================================
--- uspace/drv/test/test3/test3.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/drv/test/test3/test3.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -133,5 +133,5 @@
 
 	ddf_msg(LVL_DEBUG, "dev_add(name=\"%s\", handle=%d)",
-	    dev->name, (int) dev->handle);
+	    ddf_dev_get_name(dev), (int) ddf_dev_get_handle(dev));
 
 	test3 = ddf_dev_data_alloc(dev, sizeof(test3_t));
@@ -155,5 +155,5 @@
 static int test3_dev_remove(ddf_dev_t *dev)
 {
-	test3_t *test3 = (test3_t *)dev->driver_data;
+	test3_t *test3 = (test3_t *)ddf_dev_data_get(dev);
 	char *fun_name;
 	int rc;
Index: uspace/lib/bithenge/helenos/block.c
===================================================================
--- uspace/lib/bithenge/helenos/block.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/lib/bithenge/helenos/block.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -37,6 +37,6 @@
 
 #include <assert.h>
+#include <block.h>
 #include <errno.h>
-#include <libblock.h>
 #include <loc.h>
 #include <macros.h>
Index: uspace/lib/block/Makefile
===================================================================
--- uspace/lib/block/Makefile	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/lib/block/Makefile	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -32,5 +32,5 @@
 
 SOURCES = \
-	libblock.c
+	block.c
 
 include $(USPACE_PREFIX)/Makefile.common
